package io.chino.c3isp.buffermanager.restapi.types.datalake;

import com.fasterxml.jackson.databind.ObjectMapper;
import io.chino.c3isp.buffermanager.cfg.MySQLConfig;
import io.chino.c3isp.buffermanager.restapi.types.datalake.mysql.SecureCredentialsGenerator;
import io.chino.c3isp.buffermanager.restapi.types.requests.DataLakeFileSystemType;
import io.chino.c3isp.buffermanager.restapi.types.requests.DataLakeType;
import io.chino.c3isp.buffermanager.restapi.types.response.DataLakeStatus;
import io.chino.c3isp.buffermanager.test.BufferManagerBaseTest;
import org.junit.*;
import org.junit.runner.RunWith;
import org.junit.runners.MethodSorters;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit4.SpringRunner;

import java.net.URI;
import java.util.logging.Logger;

import static org.junit.Assert.*;

@SpringBootTest(webEnvironment=SpringBootTest.WebEnvironment.RANDOM_PORT)
@RunWith(SpringRunner.class)
@ActiveProfiles("test")
@AutoConfigureMockMvc
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class SecureCredentialsGeneratorTest extends BufferManagerBaseTest {

    /**
     * URI of the Data Lake
     */
    private static String dataLakeURI = null;
    /**
     * The password generated by {@link SecureCredentialsGenerator}, to be verified
     */
    private static String generatedPassword = null;

    /**
     * Shared instance of this test class, used to create/delete Data Lakes
     */
    private static SecureCredentialsGeneratorTest firstInstance;

    // this constructor is only called in @AfterClass to clean up the test Data Lake.

    public SecureCredentialsGeneratorTest() {
        super();
        if (firstInstance == null) {
            firstInstance = this;
        }
    }

    @BeforeClass
    public static void initTest() throws Exception {
        // init the test and the DB
        TEST_CLASS_NAME = "MySQL Password generator";
        BufferManagerBaseTest.initTestClass();
    }

    /**
     * Set up the databases required for test. This method is called AFTER @BeforeClass,
     * but before other @Test methods can be executed, so the {@link MySQLDataLakeTest}
     * gets to create the databases before they are required.
     *
     * @param config
     * @throws Exception
     */
    @Autowired
    void setUpDatabase(MySQLConfig config) throws Exception {
        if (firstInstance == this) // only create it once
            MySQLDataLakeTest.setUpDatabases(config);
    }

    @Before
    public void checkDatabaseExists() throws Exception {
        // call @Before method of superclass
        super.startTest();
        // Create data lake if not exists
        if (dataLakeURI == null) {
            createDataLake();
        }
    }

    @AfterClass
    public static void cleanUp() throws Exception {
        firstInstance.deleteDataLake();
        MySQLDataLakeTest.tearDownDatabases();
        // print psw so database can deleted manually in case of errors
        Logger.getLogger(BufferManagerBaseTest.class.getName())
                .info("password was: " + generatedPassword);
        generatedPassword = null;
        dataLakeURI = null;
        BufferManagerBaseTest.endTestClass();
    }

    @Test
    public void checkLength() {
        initTest("SecureCredentialsGeneratorTest_checkLength");
        int l = generatedPassword.length();
        int expected = 8;
        assertTrue("Password too short. Found " + l + " characters, should be at least " + expected,
                l >= expected);
    }

    @Test
    public void checkUpperCase() {
        initTest("SecureCredentialsGeneratorTest_checkUpperCase");
        int upper = 0;
        int expected = 1;
        for (int i=0; i < generatedPassword.length(); i++) {
            if(generatedPassword.toUpperCase().contains("" + generatedPassword.charAt(i))) {
                upper ++;
            }
        }

        assertTrue("Not enough uppercase chars. Found " + upper + " characters, should be at least " + expected,
                upper >= expected);
    }

    @Test
    public void checkLowerCase() {
        initTest("SecureCredentialsGeneratorTest_checkLowerCase");
        int lower = 0;
        int expected = 1;
        for (int i=0; i < generatedPassword.length(); i++) {
            if(generatedPassword.toLowerCase().contains("" + generatedPassword.charAt(i))) {
                lower ++;
            }
        }

        assertTrue("Not enough lowercase chars. Found " + lower + " characters, should be at least " + expected,
                lower >= expected);
    }

    @Test
    public void checkDigit() {
        initTest("SecureCredentialsGeneratorTest_checkDigit");
        final String digits = "1234567890";
        int digitCount = 0;
        int expected = 1;

        for (int i=0; i < generatedPassword.length(); i++) {
            if (digits.contains("" + generatedPassword.charAt(i))) {
                digitCount ++;
            }
        }

        assertTrue("The password has no digits", digitCount >= expected);
    }

    @Test
    public void checkSpecial() {
        initTest("SecureCredentialsGeneratorTest_checkSpecial");
        final String specialChars = SecureCredentialsGenerator.SPECIAL_CHARS.getCharacters();
        int special = 0;
        int expected = 1;

        for (int i=0; i < generatedPassword.length(); i++) {
            if (specialChars.contains("" + generatedPassword.charAt(i))) {
                special ++;
            }
        }

        assertTrue("The password has no special characters", special >= expected);
    }

    /**
     * Check that {@link URI#create(String)} can parse the special characters used for password gen
     */
    @Test
    public void testAllowedCharacters() {
        initTest("SecureCredentialsGeneratorTest_testAllowedCharacters");
        char current = ' ';
        try {
            for (char specialCharacter : SecureCredentialsGenerator.SPECIAL_CHARS.getCharacters().toCharArray()) {
                current = specialCharacter;
                // URI.create is used to build Data Lake URIs
                URI.create(
                        specialCharacter + ""
                );
            }
        } catch (IllegalArgumentException e) {
            System.err.println("Char '" + current + "' is not allowed in a URI.");
            throw e;
        }
    }

    private void createDataLake() throws Exception {
        callPrepareEmptyAndCheckResult(
                DataLakeFileSystemType.MYSQL,
                DataLakeType.VDL,
                result -> {
                    // read generated password from URI
                    ObjectMapper mapper = new ObjectMapper();
                    DataLakeStatus resp = mapper.readValue(
                            result.getResponse().getContentAsString(),
                            DataLakeStatus.class
                    );
                    assertNotNull("null response returned by prepareEmptyDataLake!", resp);
                    dataLakeURI = resp.getURI();
                    generatedPassword = DataLakeManager.getUrlParam(dataLakeURI, "psw");
                    assertNotNull("null password in prepareEmptyDataLake response", generatedPassword);
                }
        );
    }

    private void deleteDataLake() throws Exception {
        callReleaseDataAndCheckResult(
                dataLakeURI,
                result -> {
                    ObjectMapper mapper = new ObjectMapper();
                    String resp = result.getResponse().getContentAsString();
                    assertFalse("An error was returned by releaseData: " + resp, resp.toLowerCase().startsWith("error"));
                    assertTrue("Error - invalid response from releaseData: " + resp,
                            resp.contains("Successfully removed jdbc:mysql:")
                    );
                }
        );
    }
}